library ieee;
use ieee.std_logic_1164.all;
use std.textio.all;
use ieee.std_logic_textio.all;

entity rom is
   port ( addr: in integer range 0 to 63;
          cs,oe: in std_logic;
          dato: out std_logic_vector(31 downto 0);
          ready: out std_logic);
end rom;

architecture beh of rom is
 begin
 process(addr,cs,oe)
   type rom is array(0 to 63) of std_logic_vector(31 downto 0);
   variable mem: rom;
   variable init: boolean:= false;
   file filedati: text;
   variable linea: line;
   variable i: integer:=0;
  begin
  if init=false then
    file_open(filedati, "dati.txt", READ_MODE);
     while i < 64 and not endfile(filedati) loop
       readline(filedati,linea);
       read(linea,mem(i));
       i:=i+1;
     end loop;
     file_close(filedati);
     init:= true;
  end if;
  
  if cs = '0' then
    if oe='0' then
       dato <= mem(addr) after 5 ns;
       ready <= '1' after 5 ns;
    else dato <= (others => 'Z');
        ready <= '0' after 2 ns;
    end if;
  else  dato <= (others => 'Z');
      ready <= '0' after 2 ns;
  end if;
 end process;
end beh;    
           
     
    
           